/* code for "tabwrite_double" pd class.  This takes two messages: floating-point
numbers, and "rats", and just prints something out for each message. */

#include "m_pd.h"

t_class *tabwrite_double_class;

    /* the data structure for each copy of "tabwrite_double".  In this case we
    on;y need pd's obligatory header (of type t_object). */
typedef struct tabwrite_double
{
	t_object x_obj;
	t_symbol *x_arrayname;
	t_float x_major_float;
	t_float x_minor_float;
} t_tabwrite_double;

    /* this is called back when tabwrite_double gets a "float" message (i.e., a
    number.) */
void tabwrite_double_float(t_tabwrite_double *x, t_float f)
{
    t_garray *a;
    long npoints;
    t_word *vec;
	const long max_float = 16777216;
	
    if (!(a = (t_garray *)pd_findbyclass(x->x_arrayname, garray_class)))
        pd_error(x, "%s: no such array", x->x_arrayname->s_name);
    else if (!garray_getfloatwords(a, &npoints, &vec))
        pd_error(x, "%s: bad template for tabread", x->x_arrayname->s_name);
    else
    {
        long n = (long)x->x_minor_float+(long)x->x_major_float*max_float;
        if (n < 0) n = 0;
        else if (n >= npoints) n = npoints - 1;
        vec[n].w_float = f;
		garray_redraw(a);
    }
}

void tabwrite_double_set(t_tabwrite_double *x, t_symbol *s)
{
    x->x_arrayname = s;
}

void *tabwrite_double_new(t_symbol *s)
{
    t_tabwrite_double *x = (t_tabwrite_double *)pd_new(tabwrite_double_class);
    x->x_arrayname = s;
	floatinlet_new(&x->x_obj, &x->x_minor_float);
	floatinlet_new(&x->x_obj, &x->x_major_float);
    return (x);
}

void tabwrite_double_setup(void)
{
    tabwrite_double_class = class_new(gensym("tabwrite_double"), (t_newmethod)tabwrite_double_new,
							  0, sizeof(t_tabwrite_double), 0, A_DEFSYM, 0);
    class_addfloat(tabwrite_double_class, (t_method)tabwrite_double_float);
    class_addmethod(tabwrite_double_class, (t_method)tabwrite_double_set, gensym("set"),
					A_SYMBOL, 0);
}

